//This was modified from vgatest.c for the purpose of being used
//by videotest (a script called by diag) located within the testscripts
//directory.
// This will display one video mode then exit (eliminating the need to
// choose a video mode during testing.  Currently the video mode being
// used (defined by TESTMODE below) is 1024x768 with 64K colors.  To show
// other available modes run vgatest (also contained in the testscripts
// directory but used only for individual use, in other words, it is not
// used by diag).  The video mode displayed is then printed to the screen
// for a duration of time definded by DISPLAYMODE below.  If TESTMODE is 
// not available then the mode is decremented by one and then checked to 
// see if it is available for use.
//This program should be compiled in the same manner as vgatest (part of 
//svgalib package.  Remove vgatest.o and vgatest.c and then copy this file
//(renaming this to vgatest.c at the same) into /svgalib/demos.  Following
//this run "make demoprogs" from the /svgalib directory to build the new
//vgatest executable.  

#define TESTMODE 24
#define DISPLAYMODE 3

#include <stdio.h>
#include <unistd.h>		/* for usleep( long ) */
#include <string.h>
#include "vga.h"


static unsigned char line[2048 * 3];

static void testmode(int mode)
{
    int xmax, ymax, i, x, y, yw, ys, c;
    vga_modeinfo *modeinfo;

    char *bits;
    long size, linesize;
    char *vbuf;
    int	key;
    unsigned int temp;
    char *cPtr;
    
    vga_setmode(mode);

    modeinfo = vga_getmodeinfo(mode);

/*    printf("Width: %d  Height: %d  Colors: %d\n",
	   modeinfo->width,
	   modeinfo->height,
	   modeinfo->colors);*/
/*    printf("DisplayStartRange: %xh  Maxpixels: %d  Blit: %s\n",
	   modeinfo->startaddressrange,
	   modeinfo->maxpixels,
	   modeinfo->haveblit ? "YES" : "NO");*/

#ifdef TEST_MODEX
    if (modeinfo->colors == 256)
	printf("Switching to ModeX ... %s\n",
	       (vga_setmodeX()? "done" : "failed"));
#endif
    vga_screenoff();

    xmax = vga_getxdim() - 1;
    ymax = vga_getydim() - 1;

    vga_setcolor(vga_white());
    vga_drawline(0, 0, xmax, 0);
    vga_drawline(xmax, 0, xmax, ymax);
    vga_drawline(xmax, ymax, 0, ymax);
    vga_drawline(0, ymax, 0, 0);

    for (i = 0; i <= 15; i++) {
	vga_setegacolor(i);
	vga_drawline(10 + i * 5, 10, 90 + i * 5, 90);
    }
    for (i = 0; i <= 15; i++) {
	vga_setegacolor(i);
	vga_drawline(90 + i * 5, 10, 10 + i * 5, 90);
    }

    vga_screenon();

    ys = 100;
    yw = (ymax - 100) / 4;
    switch (vga_getcolors()) {
    case 256:
	for (i = 0; i < 60; ++i) {
	    c = (i * 64) / 60;
	    vga_setpalette(i + 16, c, c, c);
	    vga_setpalette(i + 16 + 60, c, 0, 0);
	    vga_setpalette(i + 16 + (2 * 60), 0, c, 0);
	    vga_setpalette(i + 16 + (3 * 60), 0, 0, c);
	}
	line[0] = line[xmax] = 15;
	line[1] = line[xmax - 1] = 0;
	for (x = 2; x < xmax - 1; ++x)
	    line[x] = (((x - 2) * 60) / (xmax - 3)) + 16;
	for (y = ys; y < ys + yw; ++y)	/* gray */
	    vga_drawscanline(y, line);
	for (x = 2; x < xmax - 1; ++x)
	    line[x] += 60;
	ys += yw;
	for (y = ys; y < ys + yw; ++y)	/* red */
	    vga_drawscanline(y, line);
	for (x = 2; x < xmax - 1; ++x)
	    line[x] += 60;
	ys += yw;
	for (y = ys; y < ys + yw; ++y)	/* green */
	    vga_drawscanline(y, line);
	for (x = 2; x < xmax - 1; ++x)
	    line[x] += 60;
	ys += yw;
	for (y = ys; y < ys + yw; ++y)	/* blue */
	    vga_drawscanline(y, line);
	break;

    case 1 << 15:
    case 1 << 16:
    case 1 << 24:
	for (x = 2; x < xmax - 1; ++x) {
	    c = ((x - 2) * 256) / (xmax - 3);
	    y = ys;
	    vga_setrgbcolor(c, c, c);
	    vga_drawline(x, y, x, y + yw - 1);
	    y += yw;
	    vga_setrgbcolor(c, 0, 0);
	    vga_drawline(x, y, x, y + yw - 1);
	    y += yw;
	    vga_setrgbcolor(0, c, 0);
	    vga_drawline(x, y, x, y + yw - 1);
	    y += yw;
	    vga_setrgbcolor(0, 0, c);
	    vga_drawline(x, y, x, y + yw - 1);
	}
	break;
    default:
	if (vga_getcolors() == 16) {
	    for (i = 0; i < xmax - 1; i++)
		line[i] = (i + 2) % 16;
	    line[0] = line[xmax] = 15;
	    line[1] = line[xmax - 1] = 0;
	}
	if (vga_getcolors() == 2) {
	    for (i = 0; i <= xmax; i++)
		line[i] = 0x11;
	    line[0] = 0x91;
	}
	for (i = 100; i < ymax - 1; i++)
	    vga_drawscanline(i, line);
	break;

    }
	key = getchar();
        /*if (key == 'd')
	{
		vga_dumpregs();
	}
	else if (key == 'f')
	{
    
	size = modeinfo->width * modeinfo->height;

        switch (vga_getcolors())
	{
	case 256:
	    break;
        case 1 << 16:
        case 1 << 15:
	    size <<= 1;	//16 bits    	
	    break;
        case 1 << 24:
	    size *= 3;	//24 bits    	
	    break;
	default:
	    size = 0;
	    
	}

	bits = 0;	    	
        if (size)
		bits = malloc(size);

printf ("size = %d, bits = 0x%X.\n",size, bits);
		
	if (size && (bits>0))	
	{		    
        	vbuf = vga_getgraphmem();
		memcpy(bits, vbuf ,size);	//copy videobuf to local mem

		linesize = size / modeinfo->height;//linsize = line size
printf ("vbuf = 0x%X, linesize = %d.\n",vbuf,linesize);

		{
			int i;
//			vga_setrgbcolor(0,0,0);
			for (i=0; ; i++)
			{
				memcpy(vbuf+(i*60)%(linesize),bits,size);
			}
		}
		free(bits);    
	}
	}	//end fast
        else if (key == 's')    */
	if (key == 's')
	{
	size = modeinfo->width * modeinfo->height;

        switch (vga_getcolors())
	{
	case 256:
	    break;
        case 1 << 16:
        case 1 << 15:
	    size <<= 1;	//16 bits    	
	    break;
//        case 1 << 24:
//	    size *= 3;	//24 bits    	
//	    break;
	default:
	    size = 0;
	    
	}

	// good for 256/64K colors only (as we rotate by 4 bytes)
//	bits = 0;
	linesize = size / modeinfo->height;
//	if (linesize)
//		bits = malloc(linesize);
	vbuf = vga_getgraphmem();

	while (size)
	{
		for (i= 0; i< modeinfo->height;i++)
		{
			cPtr = vbuf + i*linesize;

//			memcpy(bits+4, cPtr, linesize-4);
//			memcpy(bits, cPtr+linesize-4, 4);
//			memcpy(cPtr,bits,linesize);

//save the left 4 bytes of a line, shift rest to the left, and stuff the top
			temp = * (unsigned int *) cPtr;
			memcpy(cPtr, cPtr+4, linesize-4);
			* (unsigned int *)(cPtr+linesize-4) = temp;
		}

	}
//	free(bits);
	}	//end 'slow'
	
	    

    vga_setmode(TEXT);
}

int main(void)
{
    int mode, good_to_go;
    int i, high;

    vga_modeinfo *dinfo;
    char dexpl[100];
    char *dcols = NULL;

    vga_init();			/* Initialize. */

    mode = TESTMODE;
    if (mode > GLASTMODE) 
    {
	mode = GLASTMODE;
    }
	
    good_to_go = 0;
    while (good_to_go == 0)
    {
	if (vga_hasmode(mode))
	{
	    good_to_go = 1;
	}
	else 
	{
	    --mode;
	    if (mode < 1)
	    {
		printf("Error: No video modes supported by your driver\n");
		exit(-1);
	    }
	}
    }
    testmode(mode);
	    
    i = mode;
    *dexpl = '\0';
    dinfo = vga_getmodeinfo(i);
    switch (dinfo->colors) 
    {
    case 2:
        dcols = "2";
	strcpy(dexpl, "1 bitplane, monochrome");
	break;
    case 16:
        dcols = "16";
	strcpy(dexpl, "4 bitplanes");
	break;
    case 256:
	if (i == G320x200x256)
	    strcpy(dexpl, "packed-pixel");
	else if (i == G320x240x256
	     || i == G320x400x256
	     || i == G360x480x256)
	    strcpy(dexpl, "Mode X");
	else
	    strcpy(dexpl, "packed-pixel, banked");
	    break;
    case 1 << 15:
	dcols = "32K";
	strcpy(dexpl, "5-5-5 RGB, blue at LSB, banked");
	break;
    case 1 << 16:
	dcols = "64K";
	strcpy(dexpl, "5-6-5 RGB, blue at LSB, banked");
	break;
    case 1 << 24:
	dcols = "16M";
	if (dinfo->bytesperpixel == 3) 
	{
	    if (dinfo->flags & RGB_MISORDERED)
		strcpy(dexpl, "8-8-8 BGR, red byte first, banked");
	    else
		strcpy(dexpl, "8-8-8 RGB, blue byte first, banked");
	} 
	else if (dinfo->flags & RGB_MISORDERED)
	    strcpy(dexpl, "8-8-8 RGBX, 32-bit pixels, X byte first, banked");
	else
	    strcpy(dexpl, "8-8-8 XRGB, 32-bit pixels, blue byte first, banked");
	break;
    }//end switch
    
    if (dinfo->flags & IS_INTERLACED) 
    {
	if (*dexpl != '\0')
	    strcat(dexpl, ", ");
	strcat(dexpl, "interlaced");
    }
    if (dinfo->flags & IS_DYNAMICMODE) 
    {
	if (*dexpl != '\0')
	    strcat(dexpl, ", ");
	strcat(dexpl, "dynamically loaded");
    }
    
    high = i;
    printf("\nMODE# %d: %dx%d, ", i, dinfo->width, dinfo->height);
    if (dcols == NULL)
	printf("%d", dinfo->colors);
    else
	printf("%s", dcols);
    printf(" colors ");
    if (*dexpl != '\0')
	printf("(%s)", dexpl);
    printf("\n");
    sleep(DISPLAYMODE);	    
    exit(0);
 
} //end main
